// Sample effect file

texture tex0 : TEXTURE;

// Here is a vector parameter representing the direction
// vector from a light source.  The UIDirectional annotation
// tells EffectEdit to create a user interface element that can
// be used to interactively change the light direction.
float3 lightDir
<
    string UIDirectional = "Light Direction";
> = {0.577, 0.577, -.577};

///float time : TIME;
float time = 0; // freeze time since we're making the sun stationary

technique tec0
{
    pass p0
    {
        // Set up reasonable material defaults
        MaterialAmbient = {1.0, 1.0, 1.0, 1.0}; 
        MaterialDiffuse = {1.0, 1.0, 1.0, 1.0}; 
        MaterialSpecular = {0.0, 0.0, 0.0, 0.0}; 
        MaterialPower = 0.0f;
        
        // Set up one directional light
        LightType[0]      = DIRECTIONAL;
        LightDiffuse[0]   = {1.0, 1.0, 1.0, 1.0};
        LightSpecular[0]  = {0.0, 0.0, 0.0, 0.0}; 
        LightAmbient[0]   = {0.2, 0.2, 0.2, 0.2};
//        LightDirection[0] = <lightDir>; // Use the vector parameter defined above
        LightDirection[0] = (float3(1,1,-1)); // Use the vector parameter defined above
//        LightDirection[0] = (float3(0,0,-1)); // Use the vector parameter defined above
//        LightDirection[0] = (float3(cos(time/20),0,sin(time/20))); // Use the vector parameter defined above
        LightRange[0]     = 100000.0;
        
        // Turn lighting on and use light 0
        LightEnable[0] = true;
        Lighting = true;
        SpecularEnable = false;
        
        ZEnable = true;
        ZWriteEnable = true;
        
        // Set up texture stage 0
        Texture[0] = <tex0>; // Use the texture parameter defined above
        ColorOp[0] = Modulate;
        ColorArg1[0] = Texture;
        ColorArg2[0] = Diffuse;
//        AlphaOp[0] = Modulate;
//        AlphaArg1[0] = Texture;
//        AlphaArg2[0] = Diffuse;
        AlphaOp[0] = Disable;
        MinFilter[0] = Linear;
        MagFilter[0] = Linear;
        MipFilter[0] = Linear;
        
        // Disable texture stage 1
        ColorOp[1] = Disable;
        AlphaOp[1] = Disable;
    }
}
