//
// Water effect
//
// Note: This effect file does not work with EffectEdit.
//

texture tFLR;   // Floor texture

//half4x3 WorldView  : WORLDVIEW;
//half4x4 Projection : PROJECTION;
half4x4 WorldViewProj : WORLDVIEWPROJECTION;

//texture watertexture < string name = "Data\\Images\\Textures\\texture_water.bmp" ; >;

struct VS_OUTPUT
{
    half4 Position   : POSITION;
    half4 Spec       : COLOR0;
    half2 TexCoord   : TEXCOORD0;
};

// vertex shader
VS_OUTPUT VS (half3 Position : POSITION, half3 Normal : NORMAL)
{
    VS_OUTPUT Out = (VS_OUTPUT)0;
/*
	// project the position
//	Out.Position = mul(half4(Position,1), WorldViewProj);
    half3 P = mul(half4(Position, 1), (half4x3)WorldView);    // position (view space)
    Out.Position  = mul(half4(P, 1), Projection);             // position (projected)

    half3 N = normalize(mul(Normal, (half3x3)WorldView));   // normal (view space)
    half3 V = -normalize(P);                               // view direction (view space)
//	half3 V = half3(0,0,1);
///	half3 L = lightDir;
///    half3 R = normalize(2 * dot(N, L) * N - L);            // reflection vector (view space)

	// calculate shading
    Out.Spec = (half)pow(max(0, dot(N, V)), 8);   // specular
    Out.Spec += half4(68.0f/255.0f, 131.0f/255.0f, 157.0f/255.0f, 128.0f/255.0f);
//    Out.Spec.a = 0;
*/

	Out.Position = mul(half4(Position,1), WorldViewProj);

	float amt = (Normal.x*Normal.x + Normal.y*Normal.y);
    Out.Spec = half4(amt, amt, amt, amt + 0.5f);

	Out.TexCoord = half2(Position.x, Position.y) * 0.5f;

    return Out;
}




//
// Technique 5 - One pass, no reflection, no caustics
//

technique T5
{
    pass P0
    {
//        VertexShader = null;
        VertexShader = compile vs_1_1 VS();
        PixelShader = null;

        Lighting       = False;
        SpecularEnable = False;

        // Stage 0
        AlphaOp[0]   = SelectArg1;
        AlphaArg1[0] = Diffuse;
        AlphaArg2[0] = Texture;
/*
        ColorOp[0]   = SelectArg2;
        ColorArg1[0] = Diffuse;
        ColorArg2[0] = Current;
*/

        ColorOp[0]   = Add;
        ColorArg1[0] = Diffuse;
        ColorArg2[0] = Texture;

        MinFilter[0] = Linear;
        MagFilter[0] = Linear;
        MipFilter[0] = None;

        Texture[0]   = <tFLR>;

        AlphaBlendEnable = TRUE;
        SrcBlend         = SRCALPHA;
        DestBlend        = INVSRCALPHA;
	
        // Stage 1
        ColorOp[1]   = Disable;
        AlphaOp[1]   = Disable;
        
        CullMode = CW;
    }
}
